require "import"
import "android.widget.*"
import "com.androlua.*"
import "android.view.View"
import "android.os.Environment"
import "java.net.URLEncoder"
import "java.io.File"
import "java.io.FileOutputStream"
import "android.graphics.BitmapFactory"

function getUniqueFilename(name)
  local t = os.date("*t")
  local ts = string.format("%04d%02d%02d_%02d%02d%02d", t.year, t.month, t.day, t.hour, t.min, t.sec)
  return Environment.getExternalStorageDirectory().toString() .. "/" .. name .. "_" .. ts .. ".png"
end

function downloadImage(text, callback)
  local encoded = URLEncoder.encode(text, "UTF-8")
  local url = "https://sheikhhridoy.nagad.my.id/api/ai-art-generator.php?prompt=" .. encoded
  local path = getUniqueFilename("ai_image")
  Http.get(url, nil, function(code, content)
    if code == 200 and content then
      local f = io.open(path, "wb")
      if f then
        f:write(content)
        f:close()
        callback(true, path)
      else
        callback(false, "Write failed.")
      end
    else
      callback(false, "Error: " .. code)
    end
  end)
end

layout = {
  LinearLayout,
  orientation = "vertical",
  layout_width = "fill",
  layout_height = "fill",
  padding = "16dp",
  {
    EditText,
    id = "inputText",
    hint = "Enter prompt",
    layout_width = "fill",
    layout_height = "wrap_content",
  },
  {
    Button,
    id = "generateButton",
    text = "Generate Image",
    layout_width = "fill",
    layout_height = "wrap_content",
  },
  {
    TextView,
    id = "resultText",
    layout_width = "fill",
    layout_height = "wrap_content",
  },
  {
    ImageView,
    id = "generatedImage",
    layout_width = "fill",
    layout_height = "300dp",
    visibility = View.GONE,
  },
  {
    Button,
    id = "exitButton",
    text = "Exit",
    layout_width = "wrap_content",
    layout_height = "wrap_content",
  },
  {
    TextView,
    text = "https://t.me/schoolofmindlight2018",
    layout_width = "fill",
    layout_height = "wrap_content",
    gravity = "center",
    padding = "8dp",
  }
}

dlg = LuaDialog(this)
dlg.setTitle("AI Image Generator")
dlg.setView(loadlayout(layout))

function updateResult(t)
  resultText.text = t or ""
end

generateButton.onClick = function()
  local prompt = inputText.text
  if prompt and #prompt > 0 then
    updateResult("Generating...")
    generatedImage.visibility = View.GONE
    downloadImage(prompt, function(ok, result)
      if ok then
        local bmp = BitmapFactory.decodeFile(result)
        if bmp then
          generatedImage.setImageBitmap(bmp)
          generatedImage.visibility = View.VISIBLE
          updateResult("Saved at:\n" .. result)
        else
          updateResult("Decode failed.")
        end
      else
        updateResult(result)
      end
    end)
  else
    updateResult("Enter prompt.")
  end
end

exitButton.onClick = function()
  dlg.dismiss()
end

dlg.show()